import { EventEmitter, OnInit, OnDestroy, ChangeDetectorRef } from '@angular/core';
import { Options } from '../../interfaces/options.type';
import { Notification } from '../../interfaces/notification.type';
import { NotificationsService } from '../../services/notifications.service';
export declare class SimpleNotificationsComponent implements OnInit, OnDestroy {
    private service;
    private cdr;
    options: Options;
    onCreate: EventEmitter<{}>;
    onDestroy: EventEmitter<{}>;
    notifications: Notification[];
    position: ['top' | 'bottom' | 'middle', 'right' | 'left' | 'center'];
    private lastNotificationCreated;
    private listener;
    private lastOnBottom;
    private maxStack;
    private preventLastDuplicates;
    private preventDuplicates;
    timeOut: number;
    maxLength: number;
    clickToClose: boolean;
    showProgressBar: boolean;
    pauseOnHover: boolean;
    theClass: string;
    rtl: boolean;
    animate: 'fade' | 'fromTop' | 'fromRight' | 'fromBottom' | 'fromLeft' | 'rotate' | 'scale';
    constructor(service: NotificationsService, cdr: ChangeDetectorRef);
    ngOnInit(): void;
    defaultBehavior(value: any): void;
    add(item: Notification): void;
    block(item: Notification): boolean;
    checkStandard(checker: Notification, item: Notification): boolean;
    checkHtml(checker: Notification, item: Notification): boolean;
    attachChanges(options: any): void;
    buildEmit(notification: Notification, to: boolean): Notification;
    cleanSingle(id: string): void;
    ngOnDestroy(): void;
}
